#version 330

layout(points) in;
layout(triangle_strip) out;
layout(max_vertices = 4) out;

uniform mat4 projectionMatrix;
uniform mat4 shadowPMatrix;
uniform vec4 lightPosition;

flat in float vs_depth[];
flat in float vs_radius[];
flat in vec3 vs_color[];
flat in vec4 vs_quad[];
flat in vec4 center_viewShadowPos[];

out vec3 lightDirection;
out vec3 cameraDirection;
out vec2 offset;
out vec4 shadowPos;
flat out float depth;
flat out float radius;
flat out vec3 color;
flat out vec4 quad;

out vec4 viewPos;

void main()
{	


	//vec4 viewPos;
	

	radius = vs_radius[0];
	depth = vs_depth[0];
	quad = vs_quad[0];
	color = vs_color[0];

	offset = vec2(-2,-2);

	//shadowPos  = shadowPMatrix * (center_viewShadowPos[0] + vec4(offset * radius,0,0));
	vec4 test;
	test = (center_viewShadowPos[0] + vec4(offset * radius,0,0));
	test.z = test.z + 0.01* -test.z;
	shadowPos  = shadowPMatrix * test;
	viewPos = gl_in[0].gl_Position + vec4(offset * radius,0,0);
	lightDirection = (lightPosition - viewPos).xyz;
	lightDirection = normalize(lightDirection);
	cameraDirection = vec3(normalize(viewPos*-1));
	gl_Position = projectionMatrix * viewPos;
	EmitVertex();

	offset = vec2(2,-2);
	test = (center_viewShadowPos[0] + vec4(offset * radius,0,0));
	test.z = test.z + 0.01* -test.z;
	shadowPos  = shadowPMatrix * test;
	viewPos = gl_in[0].gl_Position + vec4(offset * radius,0,0);
	lightDirection = (lightPosition - viewPos).xyz;
	lightDirection = normalize(lightDirection);
	cameraDirection = vec3(normalize(viewPos*-1));
	gl_Position = projectionMatrix * viewPos;
	EmitVertex();


	offset = vec2(-2,2);
	test = (center_viewShadowPos[0] + vec4(offset * radius,0,0));
	test.z = test.z + 0.01 * -test.z;
	shadowPos  = shadowPMatrix * test;
	viewPos = gl_in[0].gl_Position + vec4(offset * radius,0,0);
	lightDirection = (lightPosition - viewPos).xyz;
	lightDirection = normalize(lightDirection);
	cameraDirection = vec3(normalize(viewPos*-1));
	gl_Position = projectionMatrix * viewPos;
	EmitVertex();


	offset = vec2(2,2);
	test = (center_viewShadowPos[0] + vec4(offset * radius,0,0));
	test.z = test.z + 0.01* -test.z;
	shadowPos  = shadowPMatrix * test;
	viewPos = gl_in[0].gl_Position + vec4(offset * radius,0,0);
	lightDirection = (lightPosition - viewPos).xyz;
	lightDirection = normalize(lightDirection);
	cameraDirection = vec3(normalize(viewPos*-1));
	gl_Position = projectionMatrix * viewPos;
	EmitVertex();

	EndPrimitive();
}  