// Vertex Shader  file "phongShader.vert"
#version 330
#extension GL_ARB_explicit_attrib_location : enable

//Blinn-Phong Shading

uniform mat4 modelViewMatrix;
uniform mat4 shadowMVMatrix;

//per vertex attributes
layout(location = 0) in vec4 in_position;		//in local coordinates
layout(location = 1) in float in_radius;
layout(location = 2) in vec3 in_color;
layout(location = 3) in vec4 in_quad;

flat out float vs_depth;
flat out float vs_radius;
flat out vec3 vs_color;
flat out vec4 vs_quad;

flat out vec4 center_viewShadowPos;




//out vec4 pos;

void main(void)
{

	vs_color = in_color;
	vs_quad = in_quad;
	vs_radius = in_radius;

	vec4 center_viewPos = modelViewMatrix * in_position;

	center_viewShadowPos = shadowMVMatrix * in_position;

	vs_depth = center_viewPos.z;
	gl_Position = center_viewPos;


}